.686
.MODEL FLAT,STDCALL
OPTION CASEMAP:NONE

INCLUDE \masm32\include\windows.inc
INCLUDE \masm32\include\user32.inc
INCLUDE \masm32\include\kernel32.inc
INCLUDE \masm32\include\advapi32.inc
INCLUDE \masm32\include\comctl32.inc

INCLUDELIB \masm32\lib\user32.lib
INCLUDELIB \masm32\lib\kernel32.lib
INCLUDELIB \masm32\lib\advapi32.lib
INCLUDELIB \masm32\lib\comctl32.lib

WinMain     PROTO :DWORD,:DWORD,:DWORD,:DWORD
IsVista     PROTO
IsUserAdmin PROTO

.DATA

    ClassName       BYTE "SimpleWinClass",0
    AppName         BYTE "Vista Elevation",0
    MenuName        BYTE "TheMenu",0
    ButtonClassName BYTE "button",0
    EditClassName   BYTE "edit",0
    ButtonText      BYTE "Do Something",0
    szIsElevated    BYTE "This process has administrator privileges",0
    szIsNotElevated BYTE "This process does not have administrator privileges",0
    szMsg1          BYTE "We just did something that requires elevation (not really).",0
    szMsg2          BYTE "This example is intended for Windows Vista,",10,
                         "to demonstrate how a program can request",10,
                         "to start elevated.",0

.DATA?

    hInstance   HINSTANCE ?
    CommandLine LPSTR     ?
    hwndButton  HWND      ?
    hwndEdit    HWND      ?
    bElevated   SDWORD    ?

.CONST

    ButtonID    EQU 1
    EditID      EQU 2
    
    IDM_EXIT    EQU 1

.CODE

  start:
  
    INVOKE GetModuleHandle, NULL
    mov    hInstance,eax
    INVOKE GetCommandLine
    INVOKE WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
    INVOKE ExitProcess,eax
    
;--------------------------------------    
WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD

    LOCAL wc:WNDCLASSEX
    LOCAL msg:MSG
    LOCAL hwnd:HWND
    LOCAL hMenu:HMENU
    
    INVOKE InitCommonControls
    
    mov   wc.cbSize,SIZEOF WNDCLASSEX
    mov   wc.style, CS_HREDRAW or CS_VREDRAW
    mov   wc.lpfnWndProc, OFFSET WndProc
    mov   wc.cbClsExtra,NULL
    mov   wc.cbWndExtra,NULL
    push  hInst
    pop   wc.hInstance
    mov   wc.hbrBackground,COLOR_BTNFACE+1
    mov   wc.lpszMenuName,OFFSET MenuName
    mov   wc.lpszClassName,OFFSET ClassName
    INVOKE LoadIcon,NULL,IDI_APPLICATION
    mov   wc.hIcon,eax
    mov   wc.hIconSm,eax
    INVOKE LoadCursor,NULL,IDC_ARROW
    mov   wc.hCursor,eax
    INVOKE RegisterClassEx, addr wc
    
    INVOKE LoadMenu, hInst, OFFSET MenuName 
    mov   hMenu, eax 
    
    INVOKE CreateWindowEx, WS_EX_CLIENTEDGE, ADDR ClassName, ADDR AppName,\
           WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,\
           CW_USEDEFAULT,520,200,NULL,hMenu,\
           hInst,NULL
    mov   hwnd, eax
    
    INVOKE ShowWindow, hwnd, SW_SHOWNORMAL
    INVOKE UpdateWindow, hwnd
    .WHILE TRUE
                INVOKE GetMessage, ADDR msg,NULL,0,0
                .BREAK .IF (!eax)
                INVOKE TranslateMessage, ADDR msg
                INVOKE DispatchMessage, ADDR msg
    .ENDW
    mov     eax,msg.wParam
    ret
WinMain endp
;--------------------------------------
WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

    .IF uMsg == WM_DESTROY
    
        INVOKE PostQuitMessage,NULL
        
    .ELSEIF uMsg == WM_CREATE
    
        ; Create the edit control
        INVOKE CreateWindowEx, WS_EX_CLIENTEDGE, ADDR EditClassName, NULL,\
                        WS_CHILD or WS_VISIBLE or WS_BORDER or ES_LEFT or ES_AUTOHSCROLL,\
                        50,35,400,25, hWnd, EditID, hInstance, NULL
        mov  hwndEdit, eax
        INVOKE SetFocus, hwndEdit
        
        ; Create the button control
        INVOKE CreateWindowEx, NULL, ADDR ButtonClassName, ADDR ButtonText,\
                        WS_CHILD or WS_VISIBLE or BS_DEFPUSHBUTTON,\
                        180,80,140,25, hWnd, ButtonID, hInstance, NULL
        mov  hwndButton, eax
        
        INVOKE IsUserAdmin
        .IF eax != 0
            INVOKE SetWindowText, hwndEdit, ADDR szIsElevated
        .ELSE
            INVOKE SetWindowText, hwndEdit, ADDR szIsNotElevated
        .ENDIF
        
        INVOKE IsVista
        .IF eax != 0
            INVOKE SendMessage, hwndButton, BCM_SETSHIELD, 0, TRUE    
        .ELSE    
            INVOKE MessageBox, NULL, ADDR szMsg2, ADDR AppName, MB_OK 
        .ENDIF
        
    .ELSEIF uMsg == WM_COMMAND
    
        mov eax, wParam
        .IF lParam == 0
            .IF ax == IDM_EXIT
                INVOKE DestroyWindow, hWnd
            .ENDIF
        .ELSE
            .IF ax == ButtonID
                shr eax,16
                .IF ax == BN_CLICKED
                    ; Do something here that requires administrator privileges
                    INVOKE MessageBox, NULL, ADDR szMsg1, ADDR AppName, MB_OK
                 .ENDIF
            .ENDIF
        .ENDIF
        
    .ELSE
    
        INVOKE DefWindowProc,hWnd,uMsg,wParam,lParam
        ret
        
    .ENDIF
    
    xor    eax,eax
    ret
WndProc ENDP
;--------------------------------------
IsVista PROC
    
    LOCAL osver:OSVERSIONINFO

    mov osver.dwOSVersionInfoSize, SIZEOF OSVERSIONINFO
    INVOKE GetVersionEx, ADDR osver 
    .IF (osver.dwPlatformId == VER_PLATFORM_WIN32_NT) && (osver.dwMajorVersion >= 6 )
        mov eax, TRUE
    .ELSE
        mov eax, FALSE
    .ENDIF          
    ret
IsVista ENDP
;--------------------------------------
SECURITY_NT_AUTHORITY EQU 5

IsUserAdmin PROC

    ;// Routine Description: This routine returns TRUE if the caller's
    ;// process is a member of the Administrators local group. Caller is NOT
    ;// expected to be impersonating anyone and is expected to be able to
    ;// open its own process and process token.
    ;// Arguments: None.
    ;// Return Value:
    ;//   TRUE -  Caller has Administrators local group.
    ;//   FALSE - Caller does not have Administrators local group.

    LOCAL b:SDWORD
    
    LOCAL NtAuthority:SID_IDENTIFIER_AUTHORITY
    LOCAL pAdministratorsGroup:DWORD  ; PSID
    
    mov b, 0
    INVOKE RtlZeroMemory, ADDR NtAuthority, SIZEOF NtAuthority
    lea eax, NtAuthority
    mov BYTE PTR [eax+5], SECURITY_NT_AUTHORITY

    INVOKE AllocateAndInitializeSid, \
           ADDR NtAuthority, \
           2, \
           SECURITY_BUILTIN_DOMAIN_RID, \
           DOMAIN_ALIAS_RID_ADMINS, \
           0, 0, 0, 0, 0, 0, \
           ADDR pAdministratorsGroup
        
    .IF eax
        INVOKE CheckTokenMembership, NULL, pAdministratorsGroup, ADDR b
        .IF eax == 0
             mov b, FALSE
        .ENDIF     
        INVOKE FreeSid, pAdministratorsGroup
    .ENDIF

    mov eax, b
    ret
IsUserAdmin ENDP
;---------------------------------------
END start
